diff -rNci gcc-2.7.2/reload.c gcc-2.7.2p/reload.c
*** gcc-2.7.2/reload.c	Sat Nov 11 13:23:54 1995
--- gcc-2.7.2p/reload.c	Tue Jan 23 09:25:30 1996
***************
*** 98,104 ****
  #include "hard-reg-set.h"
  #include "flags.h"
  #include "real.h"
- #include "output.h"
  
  #ifndef REGISTER_MOVE_COST
  #define REGISTER_MOVE_COST(x, y) 2
--- 98,103 ----
***************
*** 357,372 ****
  
    *picode = CODE_FOR_nothing;
  
-   /* If X is a paradoxical SUBREG, use the inner value to determine both the
-      mode and object being reloaded.  */
-   if (GET_CODE (x) == SUBREG
-       && (GET_MODE_SIZE (GET_MODE (x))
- 	  > GET_MODE_SIZE (GET_MODE (SUBREG_REG (x)))))
-     {
-       x = SUBREG_REG (x);
-       reload_mode = GET_MODE (x);
-     }
- 
    /* If X is a pseudo-register that has an equivalent MEM (actually, if it
       is still a pseudo-register by now, it *must* have an equivalent MEM
       but we don't want to assume that), use that equivalent when seeing if
--- 356,361 ----
***************
*** 735,741 ****
  {
    register int i;
    int dont_share = 0;
-   int dont_remove_subreg = 0;
    rtx *in_subreg_loc = 0, *out_subreg_loc = 0;
    int secondary_in_reload = -1, secondary_out_reload = -1;
    enum insn_code secondary_in_icode = CODE_FOR_nothing;
--- 724,729 ----
***************
*** 902,915 ****
  		  != HARD_REGNO_NREGS (REGNO (SUBREG_REG (in)),
  				       GET_MODE (SUBREG_REG (in)))))))
      {
-       /* This relies on the fact that emit_reload_insns outputs the
- 	 instructions for input reloads of type RELOAD_OTHER in the same
- 	 order as the reloads.  Thus if the outer reload is also of type
- 	 RELOAD_OTHER, we are guaranteed that this inner reload will be
- 	 output before the outer reload.  */
        push_reload (SUBREG_REG (in), NULL_RTX, &SUBREG_REG (in), NULL_PTR,
  		   GENERAL_REGS, VOIDmode, VOIDmode, 0, 0, opnum, type);
-       dont_remove_subreg = 1;
      }
  
  
--- 890,897 ----
***************
*** 971,1006 ****
        outmode = GET_MODE (out);
      }
  
-   /* Similar issue for (SUBREG:M1 (REG:M2 ...) ...) for a hard register R where
-      either M1 is not valid for R or M2 is wider than a word but we only
-      need one word to store an M2-sized quantity in R.
- 
-      However, we must reload the inner reg *as well as* the subreg in
-      that case.  In this case, the inner reg is an in-out reload.  */
- 
-   if (out != 0 && GET_CODE (out) == SUBREG
-       && GET_CODE (SUBREG_REG (out)) == REG
-       && REGNO (SUBREG_REG (out)) < FIRST_PSEUDO_REGISTER
-       && (! HARD_REGNO_MODE_OK (REGNO (SUBREG_REG (out)), outmode)
- 	  || (GET_MODE_SIZE (outmode) <= UNITS_PER_WORD
- 	      && (GET_MODE_SIZE (GET_MODE (SUBREG_REG (out)))
- 		  > UNITS_PER_WORD)
- 	      && ((GET_MODE_SIZE (GET_MODE (SUBREG_REG (out)))
- 		   / UNITS_PER_WORD)
- 		  != HARD_REGNO_NREGS (REGNO (SUBREG_REG (out)),
- 				       GET_MODE (SUBREG_REG (out)))))))
-     {
-       /* This relies on the fact that emit_reload_insns outputs the
- 	 instructions for output reloads of type RELOAD_OTHER in reverse
- 	 order of the reloads.  Thus if the outer reload is also of type
- 	 RELOAD_OTHER, we are guaranteed that this inner reload will be
- 	 output after the outer reload.  */
-       dont_remove_subreg = 1;
-       push_reload (SUBREG_REG (out), SUBREG_REG (out), &SUBREG_REG (out),
- 		   &SUBREG_REG (out), ALL_REGS, VOIDmode, VOIDmode, 0, 0,
- 		   opnum, RELOAD_OTHER);
-     }
- 
    /* If IN appears in OUT, we can't share any input-only reload for IN.  */
    if (in != 0 && out != 0 && GET_CODE (out) == MEM
        && (GET_CODE (in) == REG || GET_CODE (in) == MEM)
--- 953,958 ----
***************
*** 1011,1026 ****
       simplifies some of the cases below.  */
  
    if (in != 0 && GET_CODE (in) == SUBREG && GET_CODE (SUBREG_REG (in)) == REG
!       && REGNO (SUBREG_REG (in)) < FIRST_PSEUDO_REGISTER
!       && ! dont_remove_subreg)
      in = gen_rtx (REG, GET_MODE (in),
  		  REGNO (SUBREG_REG (in)) + SUBREG_WORD (in));
  
    /* Similarly for OUT.  */
    if (out != 0 && GET_CODE (out) == SUBREG
        && GET_CODE (SUBREG_REG (out)) == REG
!       && REGNO (SUBREG_REG (out)) < FIRST_PSEUDO_REGISTER
!       && ! dont_remove_subreg)
      out = gen_rtx (REG, GET_MODE (out),
  		  REGNO (SUBREG_REG (out)) + SUBREG_WORD (out));
  
--- 963,976 ----
       simplifies some of the cases below.  */
  
    if (in != 0 && GET_CODE (in) == SUBREG && GET_CODE (SUBREG_REG (in)) == REG
!       && REGNO (SUBREG_REG (in)) < FIRST_PSEUDO_REGISTER)
      in = gen_rtx (REG, GET_MODE (in),
  		  REGNO (SUBREG_REG (in)) + SUBREG_WORD (in));
  
    /* Similarly for OUT.  */
    if (out != 0 && GET_CODE (out) == SUBREG
        && GET_CODE (SUBREG_REG (out)) == REG
!       && REGNO (SUBREG_REG (out)) < FIRST_PSEUDO_REGISTER)
      out = gen_rtx (REG, GET_MODE (out),
  		  REGNO (SUBREG_REG (out)) + SUBREG_WORD (out));
  
***************
*** 4120,4125 ****
--- 4070,4079 ----
  {
    register int regno;
    rtx tem;
+ #ifdef REWRITE_ADDRESS
+   /* intel1 */
+   rtx rewrite_address();
+ #endif
  
    /* If the address is a register, see if it is a legitimate address and
       reload if not.  We first handle the cases where we need not reload
***************
*** 4247,4261 ****
  	return 0;
      }
  
!   /* If we have address of a stack slot but it's not valid because the
!      displacement is too large, compute the sum in a register.
!      Handle all base registers here, not just fp/ap/sp, because on some
!      targets (namely SH) we can also get too large displacements from
!      big-endian corrections.  */
    else if (GET_CODE (ad) == PLUS
! 	   && GET_CODE (XEXP (ad, 0)) == REG
! 	   && REGNO (XEXP (ad, 0)) < FIRST_PSEUDO_REGISTER
! 	   && REG_OK_FOR_BASE_P (XEXP (ad, 0))
  	   && GET_CODE (XEXP (ad, 1)) == CONST_INT)
      {
        /* Unshare the MEM rtx so we can safely alter it.  */
--- 4201,4217 ----
  	return 0;
      }
  
!   /* If we have address of a stack slot but it's not valid
!      (displacement is too large), compute the sum in a register.  */
    else if (GET_CODE (ad) == PLUS
! 	   && (XEXP (ad, 0) == frame_pointer_rtx
! #if HARD_FRAME_POINTER_REGNUM != FRAME_POINTER_REGNUM
! 	       || XEXP (ad, 0) == hard_frame_pointer_rtx
! #endif
! #if FRAME_POINTER_REGNUM != ARG_POINTER_REGNUM
! 	       || XEXP (ad, 0) == arg_pointer_rtx
! #endif
! 	       || XEXP (ad, 0) == stack_pointer_rtx)
  	   && GET_CODE (XEXP (ad, 1)) == CONST_INT)
      {
        /* Unshare the MEM rtx so we can safely alter it.  */
***************
*** 4383,4388 ****
--- 4339,4375 ----
  	}
      }
  
+   /* intel1 - even if one of the registers is still a pseudo
+              subst_reg_equivs may be able to substitute a
+              constant for it too */
+     else
+              
+     if (tem != ad && memory_address_p (mode, tem))
+       {
+         rtx tmp_rtx;
+         tmp_rtx = copy_rtx (tem);
+ 	/* Ok, we win that way.  Replace any additional eliminable
+ 	   registers.  */
+ 	subst_reg_equivs_changed = 0;
+ 	tmp_rtx = subst_reg_equivs (tmp_rtx);
+ #ifdef REWRITE_ADDRESS
+ 	if (!strict_memory_address_p (mode, tmp_rtx))
+ 	  {
+             tmp_rtx = gen_rtx (MEM, mode, tmp_rtx);
+             REWRITE_ADDRESS (tmp_rtx);
+             tmp_rtx = XEXP (tmp_rtx, 0);
+ 	  }
+ #endif
+ 
+ 	/* Make sure that didn't make the address invalid again.  */
+ 
+ 	if (strict_memory_address_p (mode, tmp_rtx))
+ 	  {
+ 	    *loc = tmp_rtx;
+ 	    return 0;
+ 	  }
+ 	
+       }
    /* If constants aren't valid addresses, reload the constant address
       into a register.  */
    if (CONSTANT_P (ad) && ! strict_memory_address_p (mode, ad))
***************
*** 4609,4626 ****
  	  {
  	    op0 = SUBREG_REG (op0);
  	    code0 = GET_CODE (op0);
- 	    if (code0 == REG && REGNO (op0) < FIRST_PSEUDO_REGISTER)
- 	      op0 = gen_rtx (REG, word_mode,
- 			     REGNO (op0) + SUBREG_WORD (orig_op0));
  	  }
  
  	if (GET_CODE (op1) == SUBREG)
  	  {
  	    op1 = SUBREG_REG (op1);
  	    code1 = GET_CODE (op1);
- 	    if (code1 == REG && REGNO (op1) < FIRST_PSEUDO_REGISTER)
- 	      op1 = gen_rtx (REG, GET_MODE (op1),
- 			     REGNO (op1) + SUBREG_WORD (orig_op1));
  	  }
  
  	if (code0 == MULT || code0 == SIGN_EXTEND || code0 == TRUNCATE 
--- 4596,4607 ----
***************
*** 4882,4918 ****
        return 0;
  
      case SUBREG:
!       if (GET_CODE (SUBREG_REG (x)) == REG)
  	{
! 	  /* If this is a SUBREG of a hard register and the resulting register
! 	     is of the wrong class, reload the whole SUBREG.  This avoids
! 	     needless copies if SUBREG_REG is multi-word.  */
! 	  if (REGNO (SUBREG_REG (x)) < FIRST_PSEUDO_REGISTER)
! 	    {
! 	      int regno = REGNO (SUBREG_REG (x)) + SUBREG_WORD (x);
  
! 	      if (! (context ? REGNO_OK_FOR_INDEX_P (regno)
! 		     : REGNO_OK_FOR_BASE_P (regno)))
! 		{
! 		  push_reload (x, NULL_RTX, loc, NULL_PTR,
! 			       context ? INDEX_REG_CLASS : BASE_REG_CLASS,
! 			       GET_MODE (x), VOIDmode, 0, 0, opnum, type);
! 		  return 1;
! 		}
! 	    }
! 	  /* If this is a SUBREG of a pseudo-register, and the pseudo-register
! 	     is larger than the class size, then reload the whole SUBREG.  */
! 	  else
  	    {
! 	      enum reg_class class = (context
! 				      ? INDEX_REG_CLASS : BASE_REG_CLASS);
! 	      if (CLASS_MAX_NREGS (class, GET_MODE (SUBREG_REG (x)))
! 		  > reg_class_size[class])
! 		{
! 		  push_reload (x, NULL_RTX, loc, NULL_PTR, class,
! 			       GET_MODE (x), VOIDmode, 0, 0, opnum, type);
! 		  return 1;
! 		}
  	    }
  	}
        break;
--- 4863,4883 ----
        return 0;
  
      case SUBREG:
!       /* If this is a SUBREG of a hard register and the resulting register is
! 	 of the wrong class, reload the whole SUBREG.  This avoids needless
! 	 copies if SUBREG_REG is multi-word.  */
!       if (GET_CODE (SUBREG_REG (x)) == REG
! 	  && REGNO (SUBREG_REG (x)) < FIRST_PSEUDO_REGISTER)
  	{
! 	  int regno = REGNO (SUBREG_REG (x)) + SUBREG_WORD (x);
  
! 	  if (! (context ? REGNO_OK_FOR_INDEX_P (regno)
! 		 : REGNO_OK_FOR_BASE_P (regno)))
  	    {
! 	      push_reload (x, NULL_RTX, loc, NULL_PTR,
! 			   context ? INDEX_REG_CLASS : BASE_REG_CLASS,
! 			   GET_MODE (x), VOIDmode, 0, 0, opnum, type);
! 	      return 1;
  	    }
  	}
        break;
***************
*** 5193,5199 ****
  	       && refers_to_regno_for_reload_p (regno, endregno,
  						SUBREG_REG (SET_DEST (x)),
  						loc))
! 	      /* If the output is an earlyclobber operand, this is
  		 a conflict.  */
  	      || ((GET_CODE (SET_DEST (x)) != REG
  		   || earlyclobber_operand_p (SET_DEST (x)))
--- 5158,5164 ----
  	       && refers_to_regno_for_reload_p (regno, endregno,
  						SUBREG_REG (SET_DEST (x)),
  						loc))
! 	      /* If the ouput is an earlyclobber operand, this is
  		 a conflict.  */
  	      || ((GET_CODE (SET_DEST (x)) != REG
  		   || earlyclobber_operand_p (SET_DEST (x)))
***************
*** 5597,5608 ****
  	      goal_mem
  	      || need_stable_sp))
  	return 0;
- 
- #ifdef NON_SAVING_SETJMP 
-       if (NON_SAVING_SETJMP && GET_CODE (p) == NOTE
- 	  && NOTE_LINE_NUMBER (p) == NOTE_INSN_SETJMP)
- 	return 0;
- #endif
  
  #ifdef INSN_CLOBBERS_REGNO_P
        if ((valueno >= 0 && valueno < FIRST_PSEUDO_REGISTER
--- 5562,5567 ----
diff -rNci gcc-2.7.2/reload.h gcc-2.7.2p/reload.h
*** gcc-2.7.2/reload.h	Thu Jun 15 12:00:35 1995
--- gcc-2.7.2p/reload.h	Tue Jan 23 09:25:30 1996
***************
*** 235,237 ****
--- 235,249 ----
  
  /* Find the places where hard regs are live across calls and save them.  */
  extern void save_call_clobbered_regs PROTO((enum machine_mode));
+ /* intel1 */
+ #define MAX_RELOAD_STACK_SLOTS 100
+ struct reload_slot_info {
+     rtx  reload_stack_slot;
+     rtx  reload_insn;
+     rtx last_store;
+     int is_loaded_to_reg;
+     int stack_slot_pseudo_reg;
+     int cur_stack_offset;
+     char reload_stack_mode;
+     unsigned reload_slot_updated:1;
+     } ;
